/*
	fast Mersenne Twister routine for Pentium4
	2002/10/19
	MITSUNARI Shigeo(herumi@nifty.com)
	
	test of mymt.lib
 */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "mymt.h"

typedef unsigned int uint32;
#define SEED 1234

static double elapsed(void)
{
	static int prev = 0;
	int now, passed;
	now = clock();
	passed = now - prev;
	prev = now;
	return passed / (double)CLOCKS_PER_SEC;
}

/* output is
31076B2F7F66E2D39F428526D15DDC35
700EECCC9CB35D74C90D4298C577D7F9
C7AC7E8FDC54DAB145C8A117269024E9
46C65C9A32D2201ECD477EABD0AE849E
F5489EEC28A81F7CE03D1F1A1DBB3576
5B99E9BA034DE878804137707CA11DDC
AEF76D4554BD6D50B673A3C9CD79C97F
5EC8C0F6192709FE8FAA8DAF0E559632
80CA0EF0715256FB0386544C05AB3925
C5D7F7224A6D2FA6E1F4C5FA3F13B4C3
5D692AE7BD005C8B9D8A9A80E3A452E9
134C2F4BFCB529505E6B40031E10C502
EEE2451364CEEB8CA6C0B7C173E619CB
65AF117389C40E6BC9EA37FACA6635D1
511C2C0E77410CF3916EE9C76F71EF3C
DE7F21EA91C95A6B6FA90FAEF8215B9C
*/

int main(void)
{
	int i, ret;
	myMT_t *mt;

	mt = myMT_Init();
	myMT_SetSeed(mt, SEED);

	printf("test of myMT\n");
	for (i = 0; i < 16; i++) {
		int j;
		for (j = 0; j < 4; j++) {
			printf("%08X", myMT_GetInt32(mt));
		}
		printf("\n");
	}

	myMT_SetSeed(mt, SEED);
	elapsed();
	ret = 0;
	for (i = 0; i < 100000000; i++) {
		ret += myMT_GetInt32(mt);
	}
	printf("asm version ret=%08X  %ftime\n", ret, elapsed());

	if (0) {
		unsigned int seed[624];
		memset(seed, 2, sizeof(seed));
		seed[0] = 1;
		myMT_SetSeeds(mt, seed, 624);
		ret = 0;
		for (i = 0; i < 10000000; i++) { ret += myMT_GetInt32(mt); }
		printf("ret=%08X\n", myMT_GetInt32(mt));

		myMT_SetSeeds(mt, seed, 623);
		ret = 0;
		for (i = 0; i < 10000000; i++) { ret += myMT_GetInt32(mt); }
		printf("ret=%08X\n", myMT_GetInt32(mt));

		seed[623] = 1;
		myMT_SetSeeds(mt, seed, 624);
		ret = 0;
		for (i = 0; i < 10000000; i++) { ret += myMT_GetInt32(mt); }
		printf("ret=%08X\n", myMT_GetInt32(mt));
	}

	myMT_Term(mt);
	return 0;
}
